      subroutine check_vecgrad
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.VECTORS'
      dimension uygradt(3,3,2,maxres),uzgradt(3,3,2,maxres)
      dimension uyt(3,maxres),uzt(3,maxres)
      dimension uygradn(3,3,2),uzgradn(3,3,2),erij(3)
      double precision delta /1.0d-7/
      call vec_and_deriv
cd      do i=1,nres
crc          write(iout,'(2i5,2(3f10.5,5x))') i,1,dc_norm(:,i)
crc          write(iout,'(2i5,2(3f10.5,5x))') i,2,uy(:,i)
crc          write(iout,'(2i5,2(3f10.5,5x)/)')i,3,uz(:,i)
cd          write(iout,'(2i5,2(3f10.5,5x))') i,1,
cd     &     (dc_norm(if90,i),if90=1,3)
cd          write(iout,'(2i5,2(3f10.5,5x))') i,2,(uy(if90,i),if90=1,3)
cd          write(iout,'(2i5,2(3f10.5,5x)/)')i,3,(uz(if90,i),if90=1,3)
cd          write(iout,'(a)')
cd      enddo
      do i=1,nres
        do j=1,2
          do k=1,3
            do l=1,3
              uygradt(l,k,j,i)=uygrad(l,k,j,i)
              uzgradt(l,k,j,i)=uzgrad(l,k,j,i)
            enddo
          enddo
        enddo
      enddo
      call vec_and_deriv
      do i=1,nres
        do j=1,3
          uyt(j,i)=uy(j,i)
          uzt(j,i)=uz(j,i)
        enddo
      enddo
      do i=1,nres
cd        write (iout,*) 'i=',i
        do k=1,3
          erij(k)=dc_norm(k,i)
        enddo
        do j=1,3
          do k=1,3
            dc_norm(k,i)=erij(k)
          enddo
          dc_norm(j,i)=dc_norm(j,i)+delta
c          fac=dsqrt(scalar(dc_norm(1,i),dc_norm(1,i)))
c          do k=1,3
c            dc_norm(k,i)=dc_norm(k,i)/fac
c          enddo
c          write (iout,*) (dc_norm(k,i),k=1,3)
c          write (iout,*) (erij(k),k=1,3)
          call vec_and_deriv
          do k=1,3
            uygradn(k,j,1)=(uy(k,i)-uyt(k,i))/delta
            uygradn(k,j,2)=(uy(k,i-1)-uyt(k,i-1))/delta
            uzgradn(k,j,1)=(uz(k,i)-uzt(k,i))/delta
            uzgradn(k,j,2)=(uz(k,i-1)-uzt(k,i-1))/delta
          enddo 
c          write (iout,'(i5,3f8.5,3x,3f8.5,5x,3f8.5,3x,3f8.5)') 
c     &      j,(uzgradt(k,j,1,i),k=1,3),(uzgradn(k,j,1),k=1,3),
c     &      (uzgradt(k,j,2,i-1),k=1,3),(uzgradn(k,j,2),k=1,3)
        enddo
        do k=1,3
          dc_norm(k,i)=erij(k)
        enddo
cd        do k=1,3
cd          write (iout,'(i5,3f8.5,3x,3f8.5,5x,3f8.5,3x,3f8.5)') 
cd     &      k,(uygradt(k,l,1,i),l=1,3),(uygradn(k,l,1),l=1,3),
cd     &      (uygradt(k,l,2,i-1),l=1,3),(uygradn(k,l,2),l=1,3)
cd          write (iout,'(i5,3f8.5,3x,3f8.5,5x,3f8.5,3x,3f8.5)') 
cd     &      k,(uzgradt(k,l,1,i),l=1,3),(uzgradn(k,l,1),l=1,3),
cd     &      (uzgradt(k,l,2,i-1),l=1,3),(uzgradn(k,l,2),l=1,3)
cd          write (iout,'(a)')
cd        enddo
      enddo
      return
      end
